
Ruby - Bug #17759

Correct `ioctl_req_t` for musl

03/29/2021 09:05 AM - xtkoba (Tee KOBAYASHI)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7:

UNKNOWN, 3.0: UNKNOWN

Description

The definition of ioctl(2) in musl is int ioctl (int, int, ...);, and this makes io.c fail to build on 64-bit musl environments with Clang/LLVM

due to shorten-64-to-32 error.

A patch is attached for a workaround. It is expected to work with glibc, musl, bionic (Android), and uClibc (which defines

__GLIBC__). I have no idea of other C libraries working on Linux.

Aside from this patch, it might be better if we could supply ./configure with the definition of ioctl_req_t using e.g.

rb_cv_ioctl_req_t_convertible=....

Associated revisions

Revision c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7 - 06/16/2021 04:17 AM - nobu (Nobuyoshi Nakada)

Configure ioctl request argument type [Bug #17759]

Revision c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7 - 06/16/2021 04:17 AM - nobu (Nobuyoshi Nakada)

Configure ioctl request argument type [Bug #17759]

Revision c2d9967f - 06/16/2021 04:17 AM - nobu (Nobuyoshi Nakada)

Configure ioctl request argument type [Bug #17759]

Revision f136c1ec804e1837f006f3abbf2ef90f1ef8134d - 06/16/2021 04:33 AM - nobu (Nobuyoshi Nakada)

Removed redundant NUM2IOCTLREQ definition [Bug #17759]

Fix up c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7.

Revision f136c1ec804e1837f006f3abbf2ef90f1ef8134d - 06/16/2021 04:33 AM - nobu (Nobuyoshi Nakada)

Removed redundant NUM2IOCTLREQ definition [Bug #17759]

Fix up c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7.

Revision f136c1ec - 06/16/2021 04:33 AM - nobu (Nobuyoshi Nakada)

Removed redundant NUM2IOCTLREQ definition [Bug #17759]

Fix up c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7.

History

#1 - 03/29/2021 10:44 AM - nobu (Nobuyoshi Nakada)

Seems more concise.

Would you commit it by yourself?

#2 - 03/29/2021 10:57 AM - mame (Yusuke Endoh)

Would you commit it by yourself?

 +1
#3 - 04/15/2021 03:41 AM - mame (Yusuke Endoh)

Hi @xtkoba

Are you ineterested in becoming a Ruby commiter?

At least, @nobu (Nobuyoshi Nakada) and I want you to have a commit bit.

If you don't mind, we will recommend that we add you as a committer.

#4 - 06/16/2021 04:17 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|c2d9967f78d2e6f93f8d9876c2b3ab25aa6b86e7.

Configure ioctl request argument type [Bug #17759]

Files

ruby-ioctl_req_t.patch 473 Bytes 03/29/2021 xtkoba (Tee KOBAYASHI)
